﻿CREATE PROCEDURE [dbo].[R6_S_Generator_Rischio]
@idReport as int,
@idModello as int
AS
BEGIN
	SET NOCOUNT ON;
-- CREO LA TABELLA #R6Capitolopdf
SELECT  R6Capitolo.id, 
		R6Capitolo.titolo, 
		R6Capitolo.testo,
		R6Capitolo.testoAlternativo,
		R6Capitolo.nuovapagina, 
		R6Capitolo.queryOracle, 
		R6Capitolo.querySql,
		R6Capitolo.indicizzato,
		a.Ordinamento
into #R6CAPITOLOPDF  FROM   
ReportSezionePers AS a INNER JOIN
R6_SezioneR6Capitolo AS b ON a.IdSezione = b.IdSezione INNER JOIN
R6Capitolo ON b.IdCapitoloPDF = R6Capitolo.id
where a.idreport = @idModello
order by a.ordinamento
-- CREO LA TABELLA #R6ParagrafoPDF
SELECT  R6Paragrafo.id, 
		R6Paragrafo.titolo, 
		R6Paragrafo.testo, 
		R6Paragrafo.queryOracle, 
		R6Paragrafo.querySql, 
		R6Paragrafo.SottoTitoloQuery,
		R6Paragrafo.SpazioNecessarioSezioneSuccessiva,
		a.Ordinamento	
into #R6PARAGRAFOPDF   
FROM  ReportSezionePers AS a INNER JOIN
               R6_SezioneR6Paragrafo AS b ON a.IdSezione = b.IdSezione INNER JOIN
               R6Paragrafo ON b.IdParagrafoPDF = R6Paragrafo.id
				where a.idreport = @idModello
				order by a.ordinamento
-- CREO LA TABELLA #R6SEZIONEPDF
SELECT 
		R6Sezione.id, 
		R6Sezione.codice, 
		R6Sezione.queryOracle, 
		R6Sezione.querySql, 
		R6Sezione.ordineQueryOracle, 
		R6Sezione.ordineQuerySql,
		a.Ordinamento
into #R6SEZIONEPDF 
FROM  ReportSezionePers AS a INNER JOIN
               R6_SezioneR6Sezione AS b ON a.IdSezione = b.idFkSezione INNER JOIN
               R6Sezione ON b.idFkC6Sezione = R6Sezione.id
WHERE (a.IdReport = @idModello)
order by a.ordinamento
SELECT  DISTINCT [#R6CAPITOLOPDF].id as idCapitolo
		,[R6ReportR6Capitolo].[ordineCapitolo] as ordineCapitolo
		,[#R6CAPITOLOPDF].[titolo] as titoloCapitolo
		,[#R6CAPITOLOPDF].[testo] as testoCapitolo
		,[#R6CAPITOLOPDF].[testoAlternativo] as testoCapitoloAlternativo		
		,[#R6CAPITOLOPDF].[nuovapagina] as nuovaPaginaCapitolo
		,[#R6CAPITOLOPDF].[queryOracle] as queryOracleCapitolo	
		,[#R6CAPITOLOPDF].[indicizzato] as indicizzatoCapitolo			
		,[#R6PARAGRAFOPDF].[id] as idParagrafo
		,[R6CapitoloR6Paragrafo].[ordineParagrafo] as ordineParagrafo
		,[#R6PARAGRAFOPDF].[titolo] as titoloParagrafo
		,[#R6PARAGRAFOPDF].[sottoTitoloQuery] as sottoTitoloParagrafo
		,[#R6PARAGRAFOPDF].[testo] as testoParagrafo
		,[#R6PARAGRAFOPDF].spazioNecessarioSezioneSuccessiva as spazioNecessarioSezioneSuccessiva	
		,isnull([#R6PARAGRAFOPDF].[queryOracle],'') as queryOracleParagrafo
		,[R6CapitoloR6Paragrafo].[indicizzato] as indicizzatoParagrafo		
		,[R6ParagrafoR6Sezione].[ordineSezione] as ordineSezione
		,[#R6SEZIONEPDF].[id] as idSezione
		,[#R6SEZIONEPDF].[codice] as codiceSezione
		,isnull([#R6SEZIONEPDF].[queryOracle],'') as queryOracleSezione
		,[R6ParagrafoR6Sezione].indicizzato as indicizzatoSezione
		,[R6ParagrafoR6Sezione].[filtroDataView] as filtroSezione
		,[R6ParagrafoR6Sezione].[titolo] as titoloSezione
		,isnull([R6ParagrafoR6Sezione].[testo],'') as testoSezione
		,isnull([R6ParagrafoR6Sezione].[testo1] ,'') as testoSezioneAlternativo
		,isnull([R6ParagrafoR6Sezione].[nota],'') as notaSezione
		,isnull([R6ParagrafoR6Sezione].[nota1],'') as notaSezioneAlternativo
		,[#R6SEZIONEPDF].Ordinamento as Ordinamento
FROM  #R6SEZIONEPDF
INNER JOIN R6ParagrafoR6Sezione ON #R6SEZIONEPDF.id = R6ParagrafoR6Sezione.idFkSezione 
INNER JOIN #R6PARAGRAFOPDF ON R6ParagrafoR6Sezione.idFkParagrafo = #R6PARAGRAFOPDF.id 
INNER JOIN R6CapitoloR6Paragrafo ON #R6PARAGRAFOPDF.id = R6CapitoloR6Paragrafo.idFkParagrafo 
INNER JOIN #R6CAPITOLOPDF ON R6CapitoloR6Paragrafo.idFkCapitolo = #R6CAPITOLOPDF.id
INNER JOIN R6ReportR6Capitolo ON #R6CAPITOLOPDF.id = R6ReportR6Capitolo.idFkCapitolo
WHERE [R6ReportR6Capitolo].idFkReport = @idReport
AND [R6CapitoloR6Paragrafo].idFkReport = @idReport 
AND [R6ParagrafoR6Sezione].idFkReport = @idReport 
ORDER BY #R6SEZIONEPDF.Ordinamento
DROP TABLE #R6CAPITOLOPDF
DROP TABLE #R6PARAGRAFOPDF
DROP TABLE #R6SEZIONEPDF
END