﻿CREATE  PROCEDURE [dbo].[sp_InsertIdSezioniIntoReportSezioniPers_Diagnosi]
@pIdReport as int,
@delimiter as char(1),
@splitstring as varchar(2000),
@utente as varchar(13),
-- Variabili per i vincoli
@CustomerHaPatrimonioBF as int,
@CustomerHasOnlyBFWallet as int,
@CustomerHaPatrimonioTerziEdHaUnSoloIntermediario as bit,
@CustomerHaPatrimonioTerzi as int,
@CustomerHasOnlyWalletByOtherInstitutes as int,
@CustomerHasNoPiramideModello as int,
@CustomerHasNoPatNonRapPoliticaInv as int,
@CustomerHasNoPatNonRapAsset as int
/*
--  GESTIONE VINCOLI
--	Ha Solo portafoglio BF
    @CustomerHasOnlyBFWallet = true
-- Il cliente ha solo portafogli presso altri istituti (più di uno)
   @CustomerHasOnlyWalletByOtherInstitutes = true
   @CustomerHaPatrimonioTerziEdHaUnSoloIntermediario = false
-- Il cliente ha portafoglio BF e portafoglio presso solo un intermediario terzo
   * Manca la informazione sul cliente che ha solo patrimonio BF
   @CustomerHaPatrimonioTerziEdHaUnSoloIntermediario = true
-- Il cliente ha solo portafogli presso altri istituti (solo uno)
   @CustomerHaPatrimonioTerziEdHaUnSoloIntermediario = true
*/
AS
BEGIN
DECLARE @idReport as int
DECLARE @rowcount as int
SET @idReport = 0
SET @rowcount = 0
SELECT  s.[Value] as idsezionepersfinale
into #SezionePers	FROM dbo.Split(@delimiter, @splitstring) AS s
-- Cliente non ha una piramide modello salvata 
if (@CustomerHasNoPiramideModello = 1)
 Begin
	update #SezionePers
	set #SezionePers.idsezionepersfinale = R6_Vincoli_Albero_Generale.IdSezione
	from R6_Vincoli_Albero_Generale  join #SezionePers
	on #SezionePers.idsezionepersfinale = R6_Vincoli_Albero_Generale.IDSezioneVincolata
	and R6_Vincoli_Albero_Generale.Vincolo = 'CHANGE'
End
-- Vincolo gestione stampa var proxati selezione Dettaglio Prodotti di terzi
IF EXISTS(
SELECT * from #SezionePers
where #SezionePers.idsezionepersfinale 
in (select [IDSezione] from [R6_Vincoli_Albero_Generale]
where [Vincolo] = 'PRINTVARPROXATI') 
)
Begin 
Delete #SezionePers
	FROM
    #SezionePers,
    R6_Vincoli_Albero_Generale
WHERE
    #SezionePers.idsezionepersfinale = R6_Vincoli_Albero_Generale.IDSezioneVincolata
	AND  R6_Vincoli_Albero_Generale.Vincolo = 'PRINTVARPROXATI'
End
if (@CustomerHaPatrimonioTerziEdHaUnSoloIntermediario = 1)
 Begin
	update #SezionePers
	set #SezionePers.idsezionepersfinale = R6_Vincoli_Albero_Generale.IdSezione
	from R6_Vincoli_Albero_Generale  join #SezionePers
	on #SezionePers.idsezionepersfinale = R6_Vincoli_Albero_Generale.IDSezioneVincolata
	and R6_Vincoli_Albero_Generale.Vincolo = 'CHANGECASESOLOINTERMEDIARIO'
End
-- Vincolo Politiva investimento patrimonio non rappresentabile
if (@CustomerHasNoPatNonRapPoliticaInv = 1)
Begin 
	Delete #SezionePers
	FROM
    #SezionePers,
    R6_Vincoli_Albero_Generale
WHERE
    #SezionePers.idsezionepersfinale = R6_Vincoli_Albero_Generale.IDSezioneVincolata
	AND  R6_Vincoli_Albero_Generale.Vincolo = 'DELETEPI'
End
-- Vincolo Asset Class patrimonio non rappresentabile
if (@CustomerHasNoPatNonRapAsset = 1)
Begin 
	Delete #SezionePers
	FROM
    #SezionePers,
    R6_Vincoli_Albero_Generale
WHERE
    #SezionePers.idsezionepersfinale = R6_Vincoli_Albero_Generale.IDSezioneVincolata
	AND  R6_Vincoli_Albero_Generale.Vincolo = 'DELETEAC'	
End
SELECT @idReport=idReport  FROM [dbo].ReportSezionePers WHERE IdReport = @pIdReport
if (@idReport > 0)
BEGIN
				DELETE FROM [dbo].[ReportSezionePers]
				  WHERE IdReport = @idReport --and Utente = @utente
END
--*********************************************************************************
--	Ha Solo portafoglio BF
		if (@CustomerHasOnlyBFWallet = 1)
		Begin
			select distinct idsezionepersfinale into #tabella from 
			(
			select 
				distinct 
				Case isnull(c.IDsezioneSintesiPatrimonio,0) when 0 then b.idsezionepersfinale else c.IdSezionebf end as idsezionepersfinale
				 from dbo.R6_Vincoli_Albero_Portafoglio a right outer join 
				#SezionePers b ON 
				a.IdSezionebf = b.idsezionepersfinale 
				left  outer join 
				R6_Vincoli_Albero_Portafoglio c ON 
				b.idsezionepersfinale = c.IDsezioneSintesiPatrimonio
				) a where a.idsezionepersfinale <> -1
			insert into dbo.ReportSezionePers
				select distinct getdate(), 
				null,
				@pIdReport as report,
				 idsezionepersfinale
				,@utente
				,null
				,null
				from #tabella
				SET @rowcount = @@rowcount
				drop table #tabella
				--drop table #SezionePers
		End
--*********************************************************************************
-- Il cliente ha solo portafogli presso altri istituti (più di uno)
-- @CustomerHasOnlyWalletByOtherInstitutes = true
--   @CustomerHaPatrimonioTerziEdHaUnSoloIntermediario = false
		else if ((@CustomerHasOnlyWalletByOtherInstitutes = 1) and
			(@CustomerHaPatrimonioTerziEdHaUnSoloIntermediario = 0))
		Begin
		-- Gestione selezioni radio button rappresentazione grafico a torta o a barre
		     Delete #SezionePers
				FROM
				#SezionePers  
			where #SezionePers.idsezionepersfinale in (
			select a.idsezionepersfinale from (
			select b.IdSezione as idsezionepersfinale, count(*) as caridnalita
			FROM
				#SezionePers a inner join R6_Vincoli_Albero_Generale b
				on a.idsezionepersfinale = b.IDSezioneVincolata 
				and b.Vincolo = 'DELETESPPT'
				group by 	b.IdSezione
				having count(*) > 1  ) a)
		select distinct idsezionepersfinale into #tabella2 from 
			(
				select 
				distinct 
				Case isnull(c.IDsezioneSintesiPatrimonio,0) 
				when 0 then b.idsezionepersfinale else c.IDSezioneTerziSintesi end as idsezionepersfinale
				 from dbo.R6_Vincoli_Albero_Portafoglio a right outer join 
				#SezionePers b ON 
				a.IDSezioneTerziSintesi = b.idsezionepersfinale 
				left  outer join 
				R6_Vincoli_Albero_Portafoglio c ON 
				b.idsezionepersfinale = c.IDsezioneSintesiPatrimonio
				) a where a.idsezionepersfinale <> -1
			insert into dbo.ReportSezionePers
			select distinct getdate(), 
			null,
			@pIdReport as report,
			 idsezionepersfinale
			,@utente 
			,null
			,null
			from #tabella2
			SET @rowcount = @@rowcount
			drop table #tabella2
			--drop table #SezionePers
		End
--*********************************************************************************
-- Il cliente ha portafoglio BF e portafoglio presso solo un intermediario terzo
--   * Manca la informazione sul cliente che ha solo patrimonio BF
--   @CustomerHaPatrimonioTerziEdHaUnSoloIntermediario = true
		else if ((@CustomerHaPatrimonioBF = 1) and
			(@CustomerHaPatrimonioTerziEdHaUnSoloIntermediario = 1))
		Begin
			Select distinct idsezionepersfinale into #tabella3 from
			(
			select 
			distinct 
			Case isnull(c.IDSezioneTerziSintesi,0) when 0 then b.idsezionepersfinale 
			else c.IDSezioneTerziDettaglio end as idsezionepersfinale
			 from dbo.R6_Vincoli_Albero_Portafoglio a right outer join 
			#SezionePers b ON 
			a.IDSezioneTerziDettaglio = b.idsezionepersfinale 
			left  outer join 
			R6_Vincoli_Albero_Portafoglio c ON 
			b.idsezionepersfinale = c.IDSezioneTerziSintesi
			) a where a.idsezionepersfinale <> -1
			insert into dbo.ReportSezionePers
			select distinct getdate(), 
			null,
			@pIdReport as report,
			 idsezionepersfinale
			,@utente 
			,null
			,null
			from #tabella3
			SET @rowcount = @@rowcount
			drop table #tabella3
			--drop table #SezionePers
		End
--*********************************************************************************
-- Il cliente ha solo portafogli presso altri istituti (solo uno)
--   @CustomerHaPatrimonioTerziEdHaUnSoloIntermediario = true
	-- Sintesi terzi sintesi
		else if ((@CustomerHasOnlyWalletByOtherInstitutes = 1) and
			(@CustomerHaPatrimonioTerziEdHaUnSoloIntermediario = 1))
		Begin
			select distinct idsezionepersfinale into #tabella4 from 
			(
            select 
			distinct 
			Case isnull(c.IDSezioneTerziSintesi,0) when 0 then b.idsezionepersfinale else c.IDSezioneTerziDettaglio end as idsezionepersfinale
			 from dbo.R6_Vincoli_Albero_Portafoglio a right outer join 
		    (
				select 
				distinct 
				Case isnull(c.IDsezioneSintesiPatrimonio,0) 
				when 0 then b.idsezionepersfinale else c.IDSezioneTerziSintesi end as idsezionepersfinale
				from dbo.R6_Vincoli_Albero_Portafoglio a right outer join 
				#SezionePers b ON 
				a.IDSezioneTerziSintesi = b.idsezionepersfinale 
				left  outer join 
				R6_Vincoli_Albero_Portafoglio c ON 
				b.idsezionepersfinale = c.IDsezioneSintesiPatrimonio
				) b ON 
			a.IDSezioneTerziDettaglio = b.idsezionepersfinale 
			left  outer join 
			R6_Vincoli_Albero_Portafoglio c ON 
			b.idsezionepersfinale = c.IDSezioneTerziSintesi
			) a where a.idsezionepersfinale <> -1 
			insert into dbo.ReportSezionePers
			select distinct getdate(), 
			null,
			@pIdReport as report,
			idsezionepersfinale,
			@utente ,
			null,
			null
			from #tabella4
			SET @rowcount = @@rowcount
			drop table #tabella4
			--drop table #SezionePers
		End
		ELSE
			Begin
			insert into dbo.ReportSezionePers
			select distinct getdate(), 
			null,
			@pIdReport as report,
			 idsezionepersfinale
			,@utente 
			,null
			,null
			from #SezionePers
			SET @rowcount = @@rowcount
			End
--*********************************************************************************
--		    SELECT getdate(),   @pIdReport as report, s.[Value], @utente
--		    FROM dbo.Split( @delimiter, @splitstring ) AS s
			drop table #SezionePers
			return @rowcount
END